var SuperDao = {
    init: function(initAppID, initApiKey, initGlobalUrl) {
            this.appID = initAppID;
            this.apiKey = initApiKey;
            this.globalUrl = initGlobalUrl;
    },
    keyword: {
        field_file: "file_",
		field_picture: "pic_",
		field_fk: "fk_", 
        post_param: {
            tableName: "table_name",
            appID: "appid",
            where: "where",
            update: "updates"
        }
    }
};
function Dao(strTableName,$http) {
    this.tableName = strTableName;
	this.$http = $http;
    this.add = {
        addValues: {},
        dao: this
    };
    this.add.begin = function() {
		this.apiCloudCompat = false;
        this.addValues = {};
        return this
    };
    this.add.set = function(strField, strValue) {
		if (strField.indexOf(SuperDao.keyword.field_file) == 0 || strField.indexOf(SuperDao.keyword.field_picture) == 0) {
			if (!(strValue instanceof File)) {
				this.apiCloudCompat = true;
			}
		}
        this.addValues[strField] = strValue;
        return this;
    };
    this.add.save = function(callback) {
        Dao.prototype.save(this.apiCloudCompat, this.dao.tableName, this.addValues, callback)
    };
    this.find = {
        dao: this
    };
    this.find.select = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.selectCondition[this.selectCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "none"
        };
        return this
    };
    this.find.and = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.selectCondition[this.selectCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "and"
        };
        return this
    };
    this.find.or = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.selectCondition[this.selectCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "or"
        };
        return this
    };
    this.find.limit = function(start, quantitys) {
        this.limitCondition[0] = start;
        this.limitCondition[1] = quantitys;
        return this
    };
    this.find.orderASC = function(field) {
        this.orderCondition[this.orderCondition.length] = {
            "field": field,
            "order": "ASC"
        };
        return this
    };
    this.find.orderDESC = function(field) {
        this.orderCondition[this.orderCondition.length] = {
            "field": field,
            "order": "DESC"
        };
        return this
    };
	/**
	 * 鎺ユ敹瀛楃涓插弬鏁帮紝杩囨护鏌ユ壘缁撴灉鐨勫瓧娈�
	 * (1) 鍙傛暟锛氭帴鏀朵竴涓瓧绗︿覆瀵硅薄锛屼緥濡�: "name"銆�"name, sex"
	 */
	this.find.filter = function(filterField){
		// Start : 澶勭悊閲嶅鐨勫瓧娈靛悕
		var db_fields = filterField.split(",");
		for(i = -1; ++i < db_fields.length;){
			db_fields[i] = db_fields[i].replace(/^\s+|\s+$/g, "");
			if(this.filterResult.toString().indexOf(db_fields[i]) == -1){
				this.filterResult.push(db_fields[i]);
			}
		}
		// start : 澶勭悊閲嶅鐨勫瓧娈靛悕
		return this;
	};
    this.find.begin = function() {
        this.orderCondition = new Array();
        this.limitCondition = new Array();
        this.selectCondition = new Array();
		this.filterResult = new Array();
        return this
    };
    this.find.end = function(callback) {
        Dao.prototype.find(this.dao.tableName, this.selectCondition, this.limitCondition, this.orderCondition, this.filterResult, callback)
    };
    this.remove = {
        dao: this
    };
    this.remove.select = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.removeCondition[this.removeCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "none"
        };
        return this
    };
    this.remove.and = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.removeCondition[this.removeCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "and"
        };
        return this
    };
    this.remove.or = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.removeCondition[this.removeCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "or"
        };
        return this
    };
    this.remove.begin = function() {
        this.removeCondition = new Array();
        return this
    };
    this.remove.end = function(callback) {
        Dao.prototype.remove(this.dao.tableName, this.removeCondition, callback)
    };
    this.modify = {
        dao: this
    };
    this.modify.set = function(strField, strValue) {
        if (strField.indexOf(SuperDao.keyword.field_file) == 0 || strField.indexOf(SuperDao.keyword.field_picture) == 0) {
            if (strValue instanceof File && this.apiCloudCompat == false) {
                this.modifyFiles[strField] = strValue;
            } else {
				this.apiCloudCompat = true;
                // alert('the table field name "' + strField + '" need a File type parameter, but you delivery a non file parameter.');
				this.modifyFiles[strField] = strValue;
                return this;
            }
        } else {
			if(strValue instanceof File){
				alert("瀛楁鍚嶄笉鏄痜ile_鎴栬€卲ic_寮€澶寸殑锛屾搷浣滄嫆缁濓紝璇疯仈绯绘暟鎹簱绠＄悊鍛樸€�");
			}else{
				this.modifyValues[this.modifyValues.length] = {
                "field": strField,
                "value": strValue
				}
			}
        }
        return this
    };
    this.modify.select = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.modiryCondition[this.modiryCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "none"
        };
        return this
    };
    this.modify.and = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.modiryCondition[this.modiryCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "and"
        };
        return this
    };
    this.modify.or = function(strTableField, strCondition) {
        strCondition = convertLikeCondition2(strCondition);
        this.modiryCondition[this.modiryCondition.length] = {
            "field": strTableField,
            "value": strCondition,
            "type": "or"
        };
        return this
    };
    this.modify.begin = function() {
		this.apiCloudCompat = false;
        this.modifyFiles = {};
        this.modifyValues = new Array();
        this.modiryCondition = new Array();
        return this
    };
    this.modify.end = function(callback) {
        Dao.prototype.modify(this.apiCloudCompat, this.dao.tableName, this.modiryCondition, this.modifyValues, this.modifyFiles, callback)
    }
}
Dao.prototype.save = function(isApiCloudMode, strTableName, mapfields, callback) {
	if(isApiCloudMode){
		var fileParam = {};
		var valueParam = {};
		for (var p in mapfields) {
			if (typeof(mapfields[p]) != "function") {
				if (p.indexOf(SuperDao.keyword.field_file) == 0 || p.indexOf(SuperDao.keyword.field_picture) == 0) {
					fileParam[p] = mapfields[p];
				}else{
					valueParam[p] = mapfields[p];
				}
			}
		}
		valueParam["table_name"] = strTableName;
		valueParam["appid"] = SuperDao.appID;
		alert(valueParam["appid"] + "aaa");
		var form = {values:valueParam, files:fileParam};
		httpPost(isApiCloudMode, SuperDao.globalUrl + "/superDao/api/add.php", form,
		function(encryptData) {
			callback(encryptData);
		})
	}else{
		var form = new FormData();
		for (var p in mapfields) {
			if (typeof(mapfields[p]) != "function") {
				form.append(p, mapfields[p])
			}
		}
		form.append("table_name", strTableName);
		form.append("appid", SuperDao.appID);
		httpPost(isApiCloudMode, SuperDao.globalUrl + "/superDao/api/add.php", form,
		function(encryptData) {
			callback(encryptData)
		})
	}
};
Dao.prototype.find = function(strTableName, arrCondition, limitCondition, orderCondition, filterResult, callback) {
    var where = encodeURIComponent(JSON.stringify(arrCondition)).replace(/\'/g, "%27");
    var limit = encodeURIComponent(JSON.stringify(limitCondition)).replace(/\'/g, "%27");
    var order = encodeURIComponent(JSON.stringify(orderCondition)).replace(/\'/g, "%27");
	var filter = encodeURIComponent(JSON.stringify(filterResult)).replace(/\'/g, "%27");
    httpPost(false, SuperDao.globalUrl + "/superDao/api/find.php", "table_name=" + strTableName + "&appid=" + SuperDao.appID + "&where=" + where + "&limit=" + limit + "&order=" + order + "&filter=" + filter,
    function(encryptData) {
        callback(encryptData)
    });
};
Dao.prototype.remove = function(strTableName, arrCondition, callback) {
    httpPost(false, SuperDao.globalUrl + "/superDao/api/remove.php", "table_name=" + strTableName + "&appid=" + SuperDao.appID + "&where=" + encodeURIComponent(JSON.stringify(arrCondition)).replace(/\'/g, "%27"),
    function(encryptData) {
        callback(encryptData)
    })
};
Dao.prototype.modify = function(isApiCloudMode, strTableName, arrCondition, modefyValues, modifyFiles, callback) {
	var form = "";
	
	if(isApiCloudMode){
		var valueParam = {};
		valueParam['table_name'] = strTableName;
		valueParam['appid'] = SuperDao.appID;
		valueParam['where'] = JSON.stringify(arrCondition);
		valueParam['updates'] = JSON.stringify(modefyValues);
		var fileParam = modifyFiles;
		form = {
			values:valueParam,
			files:fileParam
		};
	}else{
		form = new FormData();
		form.append("table_name", strTableName);
		form.append("appid", SuperDao.appID);
		form.append("where", JSON.stringify(arrCondition));
		form.append("updates", JSON.stringify(modefyValues));
		for (var p in modifyFiles) {
			if (typeof(modifyFiles[p]) != "function") {
				form.append(p, modifyFiles[p])
			}
		}
	}
	
	httpPost(isApiCloudMode, SuperDao.globalUrl + "/superDao/api/modify.php", form,
		function(encryptData) {
			callback(encryptData);
		}
	);
};
function convertLikeCondition2(strLike) {
    var reg = /^\s*[?\uff1f]\s*/i;
    if (reg.test(strLike)) {
        var s = strLike.replace(reg, "");
        s = s.replace(/\\/g, "\\\\\\\\");
        s = s.replace(/\"/g, '\\"');
        s = s.replace(/%/g, "\\%");
        s = ' like "%' + s + '%"';
        return s
    }
    reg = /^\s*like\s*/i;
    if (reg.test(strLike)) {
        var s = strLike.replace(reg, "");
        s = s.replace(/\\/, "\\\\\\\\");
        s = s.replace(/\"/g, '\\"');
        s = ' like "' + s + '"';
        return s
    }
    reg = /^\s*(!=|>=|<=|=|>|<)\s*/;
    var matchResult = reg.exec(strLike);
    if (matchResult != null) {
        var s = strLike.replace(reg, "");
        if (/^(\d)*$/.test(s)) {
            return matchResult[0] + '"' + s + '"'
        } else {
            s = s.replace(/\"/g, '\\"');
            return matchResult[0] + '"' + s + '"'
        }
    }
    alert("condition format error : " + strLike);
    throw "condition format error : " + strLike
}

function httpPost(isApiCloudMode, urlto, params, callback) {
	if(isApiCloudMode){
		api.ajax({url:urlto, method:"post", data:params}, function(ret, err){
			alert(JSON.stringify(ret));
			callback(JSON.stringify(ret));
		});
	}else{
		if(this.$http != undefined){
			$http.post(urlto,params).success(function(result){
				callback(result);
			})
		}else{
			var request = new XMLHttpRequest();
			request.open("POST", urlto, true);
			if (! (params instanceof FormData)) {
				request.setRequestHeader("cache-control", "no-cache");
				request.setRequestHeader("contentType", "text/html;charset=uft-8");
				request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded")
			}
			request.onreadystatechange = function() {
				if (request.readyState == 4) {
					if (request.status == 200) {
						callback(request.responseText)
					} else {}
				}
			};
			//request.onerror = 
			
			request.send(params);
		}
	}
};