(function(window){
   var HJL={};
   
   //Adapter适配器
   HJL.Adapter = function(){
       this.initialize();
   }
   
   HJL.Adapter.prototype.initialize = function(){
       this.observers = [];
       this.modeldata=[];
   }
   
   HJL.Adapter.prototype.addModelData = function(data){
       this.modeldata.push(data);
   }
   
   HJL.Adapter.prototype.getModel = function(){
       return this.modeldata;
   }
   
   HJL.Adapter.prototype.registerObserver = function(viewcontroller){
        var arr = _.where(this.observers,viewcontroller);
	    if(arr){
	        this.observers.push(viewcontroller);
	    }  
   }
   
   HJL.Adapter.prototype.unregisterObserver = function(viewcontroller){
      this.observers = _.filter(this.observers, function(item) {
	     return item.controllerid !== viewcontroller.controllerid;
	  });
   }
   
   HJL.Adapter.prototype.notifyDataChanged = function(datas){
      var modelList = this.getModel();
      for(var i=0;i<modelList.length;i++){
          var isChange=false;
          for(var j=0;j<datas.length;j++){
              for(var key in modelList[i]){
                 if(datas[j][key] === undefined){
                    break;
                 }else{
                    if(datas[j][key] != modelList[i][key]){
                       isChange=true;
                       break;
                    }
                 }
              }
              if(isChange){
                 modelList[i]=datas[j];
                 break;
              }
          }

      }
      
      $.each(this.observers,function(index,viewcontroller){
         
         if (_.isObject(viewcontroller))
           _.execute(viewcontroller.update, viewcontroller, modelList[index]);
      })
   }
   
   //控制器
   HJL.ViewController = function(options){
   
      var _initialize = function () {
	    this.controllerid = _.uniqueId();
	  }
	  
	  var _handleOptions = function(options) {
	   
	    if (options) {
	      
	      if (_.isObject(options))
	        _.extend(this, options);
	    };
	  }
	  
	  var _handleAdapter=function () {
	    if (this.adapter) {
	      this.adapter.registerObserver(this);
	      this.adapter.addModelData(this.data);
	    }
	  }
	  
	  var _create = function(){
	     var data = this.data;
	     this.render(data);
	  }
	 
	  _.execute(_initialize,this);
	  _.execute(_handleOptions,this,options);
	  _.execute(_handleAdapter,this);
	  _.execute(_create,this);
   }
   
   
   
   HJL.ViewController.prototype.render=function(data){
       var view = $(this.view);
	   view.find('[lg-model]').each(function(){
	       var name=$(this).attr('lg-model');
	       $(this).text(data[name]);
	   })
	   
	   view.find('[lg-src]').each(function(){
	        var name=$(this).attr('lg-src');
	        $(this).attr('src',data[name])
	   })
	   
	   view.find('[lg-repeat]').each(function(){
	       var name = $(this).attr('lg-repeat');
	       for(var i=0;i<data[name].length;i++){
	           if(i==0){
		            $(this).text(data[name][i]);
		       }else{
		           var $newNode = $(this).clone(true);
			       $newNode.text(data[name][i]);
			       $newNode.prependTo($(this));
		       }
	       }
	   })
	   
   }
   
   HJL.ViewController.prototype.update=function(data){
       this.render(data);
   }
   
   
   
   window.HJL = HJL;
})(window)