
(function($, ua) {

    var
        isChrome = /chrome/i.exec(ua),
        isAndroid = /android/i.exec(ua),
        hasTouch = 'ontouchstart' in window && !(isChrome && !isAndroid);
    
   
    $.fn.ripple = function(options) {
        var rippled = false,pertime,
            opts = $.extend({}, { color: '#CDCDB4' }, options);
            
        var pertime;
        opts.event = (hasTouch && 'touchstart.ripple') || 'mousedown.ripple';
        opts.end_event = (hasTouch && 'touchend.ripple touchcancel.ripple') || 'mouseup.ripple mouseleave.ripple';
        
        $(this)
           
            .on(opts.event, function(ev) {
                var x, y, touch_ev,
				    date = new Date(),
                    $paper = $(this),
                    $ink = $('<div/>'),
                    size = Math.max($paper.width(), $paper.height());
					$bg = $('<div/>');
			       
                pertime = date.getTime();    
				
                rippled = true;
                
                
                $paper
                    .trigger('beforeripple')
                    .addClass('ripple-active');
                $ink
                    .addClass('ripple-effect')
                    .css({height: $paper.height(), width: $paper.height()});
                
               
                touch_ev = hasTouch ? ev.originalEvent.touches[0] : ev;
                x = touch_ev.pageX - $paper.offset().left - $ink.width()/2;
                y = touch_ev.pageY - $paper.offset().top - $ink.height()/2;
                $bg
				   .addClass('bg')
				   .css({height:'100%',width:'100%',backgroundColor: 'rgba(0,0,0,0.1)'})
				   .appendTo($paper);
				   
                
                $ink
                    .css({top: y + 'px', left: x + 'px', backgroundColor: opts.color})
                    .appendTo($paper);
                event.stopPropagation()
               
            })
            .on('touchmove',function(){
                event.preventDefault();
            })
            .on(opts.end_event, function() {
                
                var $paper = $(this),
                    $ink = $paper.find('.ripple-effect'),
                    nowTime = new Date().getTime(),
					$bg = $paper.find('.bg');
             
                if (!rippled) {
                    return;
                }
				$ink.css({
					webkitAnimation:'ripple 2s'
				})
				
                rippled = false;
                $bg.css({backgroundColor: 'transparent'});
                $bg.remove();
                $paper
                    .trigger('afterripple')
                    .removeClass('ripple-active');
                $ink
                    .css({backgroundColor: 'transparent'})
                    .one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function() {
                       
                        $ink.remove();
                    });
                var nTime = new Date().getTime();
                if(nTime-pertime>=150){
                    $ink.remove();
                }
                
              
              
            });

       
        return $(this);
    };

}(window.jQuery, navigator.userAgent));
